clear;
clc;
close all;

I = im2double(imread('Pics/10.jpg'));

% apply artificial blur 
len = 30; theta = 45;
psf = fspecial('motion', len, theta);
cfft = psf2otf(psf, size(I));
Ifft = fft2(I);
Ib = real(ifft2(Ifft.*cfft));

% brighten picture
Ibright = Ib .* 5;
Ibright(Ibright > 1) = 1;

% deblurr - assuming the motion blur is known
nsr_est = 0.0001;
Ideblur = deconvwnr(Ibright, psf, nsr_est);

% denoise
sigma = 1;
filterSize = 2*sigma+1;
gauss = fspecial('gaussian',2*sigma+1,sigma);
Ideblur_denoise = imfilter(Ideblur, gauss);

figure
subplot(1,4,1)
imshow(I)
title('Original image')
subplot(1,4,2)
imshow(Ibright)
title('Motion blurred - brightened')
subplot(1,4,3)
imshow(Ideblur)
title('Deblurred')
subplot(1,4,4)
imshow(Ideblur_denoise)
title('Denoised')

